#!/bin/env python
"""This module must implement MoinMoin events and event sources."""

from base import PAST, FUTURE, EventSource, Event

class MoinEventSource(EventSource):
    class MoinEvent(Event):
        def __init__(self, eventId, start, end, name="No name"):
            Event.__init__(self, start, end)
            self.__eventId=eventId
            self.name=name

        def __cmp__(self, ev):
            return cmp(self.eventId,ev.eventId)

        def __str__(self):
            return "%d, %s - %s: %s" % (self.__eventId,
                                        self.start==PAST and "PAST" or self.start,
                                        self.end==FUTURE and "FUTURE" or self.end,
                                        self.name)
        def __eq__(self, ev):
            return ev.__class__==MoinEventSource.MoinEvent and self.__eventId==ev.__eventId

        def __hash__(self):
            return ((self.__eventId+1) * 1999)

    def getEvents(self, start, end):
        # TODO implement: search wiki pages or whatever needed
        from datetime import datetime
        MoinEvent = MoinEventSource.MoinEvent
        return [MoinEvent(2,datetime(2006,1,12,13,0), datetime(2006,1,12,13,45), "any"),
                MoinEvent(4,datetime(2006,1,14,0,15), datetime(2006,1,14,0,45), "night"),
                MoinEvent(6,PAST, datetime(2006,2,2), "until"),
                MoinEvent(11,datetime(2005,3,14,2,17), FUTURE, "from")
                ]
        
# ---------- Main ----------
if __name__=="__main__":
    # create events, print
    from base import Events
    from datetime import datetime, timedelta
    from base import Events, EventIterator
    
    evts = Events(datetime.today(), datetime.now(), [MoinEventSource()])
    print evts, "\n"

    # get some events, print
    for evt in evts.getEvents(PAST, datetime(2006,1,14)):
        print evt
    print

    # iterate events
    iEvts = EventIterator(evts, datetime(2006,1,1), datetime(2006,2,3), timedelta(days=7))
    for evtSet in iEvts:
        print iEvts.curStart, len(evtSet)
