#!/bin/env python
import sys

from evcal.base import EventSource, Event, Events, FUTURE
from evcal.render import Cal, MonthCalendarRenderer, WeekCalendarRenderer
from datetime import datetime, timedelta
    
class TestEventSource(EventSource):
    class TestEvent(Event):
        def __init__(self, eventId, start, end, name="No name"):
            Event.__init__(self, start, end)
            self.__eventId=eventId
            self.name=name

        def __cmp__(self, ev):
            return cmp(self.eventId,ev.eventId)

        def __str__(self):
            return "%d, %s - %s: %s" % (self.__eventId,
                                        self.start==PAST and "PAST" or self.start,
                                        self.end==FUTURE and "FUTURE" or self.end,
                                        self.name)
        def __eq__(self, ev):
            return ev.__class__==TestEventSource.MoinEvent and self.__eventId==ev.__eventId

        def __hash__(self):
            return ((self.__eventId+1) * 1999)

    def getEvents(self, start, end):
        from datetime import datetime
        TestEvent = TestEventSource.TestEvent
        return [TestEvent(2,datetime(2006,6,12,13,0), datetime(2006,6,12,13,45), "any"),
                TestEvent(4,datetime(2006,6,14,0,15), datetime(2006,6,14,2,45), "night"),
                TestEvent(6,datetime(2006,6,13), datetime(2006,6,19,12,30), "until"),
                TestEvent(11,datetime(2006,6,17,9,0), FUTURE, "from"),
                TestEvent(12,datetime(2006,6,14,1,0), datetime(2006,6,14,11,0), "prepare")
                ]

# ---
evts = Events(datetime.today(), datetime.now(), [TestEventSource()])

cal = Cal()
params = dict()
params["monthlywidth"] = 600
params["weeklywidth"] = 600
    
r = MonthCalendarRenderer(evts, 2006, 6, cal, params)
r.render(formatter=open("monthly.html", "w"))

r = WeekCalendarRenderer(evts, datetime(2006, 6, 14), cal, params)
r.render(formatter=open("weekly.html", "w"))

print "rendered to monthly.html and weekly.html"
